/*
	Constantes et variables
_____________________________________
	Machine Double toile		09/09/2004, 17/02/2005
	Fuzzy, Positon Reg
	Pour DS1104
	light version Lotfi BAGHLI			  rev 12/12/2006
*/
                                            
/* Machine (une partie des donnes) */

volatile double Rsmod=6.7;
#define Rs	2.34
#define sigma 0.2041
#define Ls 32.8e-3
#define Lr 32.8e-3
#define Rr 1.170
#define M 0.0293
//#define Lldq 6.7e-3
//#define Llxy 6.7e-3
//#define Lloo 6.7e-3
#define Trconst 0.0296
#define P	4
#define r3	1.7320508075689
#define r3b2	3.4641016151378

/* constantes */
#define PI			3.14159265358979323846
#define TWOPI		6.283185307179586
#define E_2			300.0				/* tension du pont / 2 */
const double BY_2E_2=0.0016666666666666666666666666666667;

/* encoder , new DS1104 fct */
#define POStoRD_S		-1.53398078788564122972		/* Te=1 ms */
#define POStoRD		-1.53398078788564122972e-3


/* parameters for PWM initialization */
double MLIperiod=1.0e-4;		/* MLI  100 us */
Float64 deadband = 0.0;                                   /* deadband period */
Float64 sync_pos = 0.5;           /* position of the synch. interrupt signal */

#define DT 2.0e-4						/* boucle  200 us , mais MLI  100 us */
#define DS_IReg 2						/* down sampling de la reg Idq % MLI  !DS1104! */
#define DS_WReg 5						/* down sampling de la reg vitesse % Reg Idq */
#define DS_PReg 2                /* down sampling de la reg position % Reg W */
Float64 exec_time;                                         /* execution time */

//#define IsmaxProtect		16.0  // Ieff max=11.4 A
#define IsmaxProtect		20.0  // Ieff max=14.3 A

#define IdsrefBase		6.0   //-- //8.944
#define WmBaseB	62.832	/* 600tr/mn */
#define WmBase		73.304 	/* 700tr/mn */
#define Kdeflux	550 		/* 655.6294 */

#define Idsref1 8.944
#define Idsref2 5.217
#define Idsref3 2.504

#define Wmlim1b 62.832
#define Wmlim1 73.304
#define Wmlim2b 115.192
#define Wmlim2 125.664


/*---------------------------------------------------------------------------*/

/* variables for communication with Slave DSP */
Int16 task_id = 0;                                  /* communication channel */
Int16 index = -1;                                 /* slave DSP command index */
Int16 ch2_index = -1; /* slave DSP command index for ch. 2 */
Int16 ch3_index = -1; /* slave DSP command index for ch. 3 */
Int16 ch4_index = -1; /* slave DSP command index for ch. 4 */
Int16 scmpr_update_index = -1;                                 /* slave DSP scmpr_update_index command index */

/* parameters accessed by ControlDesk */
volatile Float64 duty1 = 0.5;
volatile Float64 duty2 = 0.5;
volatile Float64 duty3 = 0.5;

// ceux de la double toile
UInt32 scmpr_duties[SLVDSP_USRFCT_SIMPLEPWMUPDATE_PCNT];
volatile Float64 dduty1 = 0.5;
volatile Float64 dduty2 = 0.5;
volatile Float64 dduty3 = 0.5;

/*---------------------------------------------------------------------------*/

/* les courants */
double Ias=0.0;
double Ibs=0.0;
double Ics=0.0;
double Ialphas, Ibetas;
// double toile
double dIas=0.0;
double dIbs=0.0;
double dIcs=0.0;

/* cos sin */
double c, s;
double e;

/* Les tensions */
double Vas=0.0;
double Vbs=0.0;
double Vcs=0.0;
double	Valphas, Vbetas,
				Vdsref, Vqsref;

// double toile
double dVas=0.0;
double dVbs=0.0;
double dVcs=0.0;
double	Vxs=0.0;
double	Vys=0.0;
double	Vo1s=0.0;
double	Vo2s=0.0;
volatile double Vdb=0.0;	//45.0 ou 2*tm/TMLI*E_2=18 V

/* Les fem s */
double Ealphas, Ebetas;

double th=0.0;                                          	/* theta s */
                

/* regulateurs PI courant */
volatile double Kpq=45;
volatile double Kiq=2.264;
/* #define VqsrefMax	211.0 est varible */
double 	xeq=0.0;
double Vqsref = 0.0;
volatile double VqsrefMax=211.0;

volatile double Kpd=45;
volatile double Kid=2.264;
#define VdsrefMax	211.0
double 	xed=0.0;
double Vdsref = 0.0;

double	Ids, Iqs, e;

/* regulateur IP antiwindup vitesse */
volatile double 	KpW=2.2;
volatile double 	KiW=0.1;
volatile double 	KTiW=1.0;
#define IqsrefMax	16.0	
#define xeWMax		1000.0

double	xeW=0.0;
double	WmMesure=0.0;
double	Wm=0.0;
double	OldSortie=0.0;
double	OldSortieSat=0.0;
volatile double	Wmref=0.0;
double	absWm;

/* encoder */
float Oldmpos;
double FIR_Wm[5];
long	inc_k;
long	inc_kOld=0;

/* regulateur P position */
/* !!! float mpos;						*/
double	mpos=0.0;			/* position rd */
double	mposref=0.0;	/* position reference rd */
double KpP=17.5;
#define WmrefMax	62.832

/* ceux du decouplage */
double Wsl, Ws;
double 	Phidr=0.0;

/* Ids */
double	IdsErr, IdsErr_hN, IdsErr_hZ, IdsErr_hP,		/* erreur */
			IdsOldE,
			IdsdErr, IdsdErr_hN, IdsdErr_hZ, IdsdErr_hP,	/* derivee erreur */
			IdsdU, IdsdU_hN, IdsdU_hZ, IdsdU_hP;			/* sortie */
/* Facteurs ( Gain ) des fonctions d'appartenances floues ... */
volatile double 	IdsFErr=0.5;		/* 0.5 */
volatile double 	IdsFdErr=2.0;		/* 2.0 */
volatile double 	IdsFdU=5.0;		/* 15.0; */


/* Iqs */
double	IqsErr, IqsErr_hN, IqsErr_hZ, IqsErr_hP,		/* erreur */
			IqsOldE,
			IqsdErr, IqsdErr_hN, IqsdErr_hZ, IqsdErr_hP,	/* derivee erreur */
			IqsdU, IqsdU_hN, IqsdU_hZ, IqsdU_hP;			/* sortie */
/* Facteurs ( Gain ) des fonctions d'appartenances floues ... */
volatile double 	IqsFErr=0.5;		/* 0.5 */
volatile double 	IqsFdErr=2.0;		/* 2.0 */
volatile double 	IqsFdU=5.0;		/* 15.0; */


/* vitesse */
double	WErr, WErr_hN, WErr_hZ, WErr_hP,		/* erreur */

			WdErr, WdErr_hN, WdErr_hZ, WdErr_hP,	/* derivee erreur */
			WdU, WdU_hN, WdU_hZ, WdU_hP;			/* sortie */
double 	OldWE=0.0;

/* init la zone d'echange avec host */
/* changement ---Pic des fonctions d'appartenances floues ...
					en Facteurs ( Gain ) */
double 	WFErr=0.025;
double 	WFdErr=0.5;
double 	WFdU=7.0;	/* nouveau banc */

/* variables for execution time profiling */
unsigned int countCurrent=0;				/* Boucle de courant = 2 * 0.1 ms =0.2 ms */
unsigned int countSpeed=0;					/* Boucle de vitesse = 5 * 0.2 ms =1 ms */
unsigned int countPos=0;						/* Boucle de position = 2 * 1 ms */

/* Flags du type de controle */
volatile int CurrentControllerType=0;	/* 0 = PI,  1= Fuzzy */
volatile int SpeedControllerType=0;		/* 0 = IP,  1= Fuzzy,   2=NN,   3=3dnfF,    4=PIadapt   */

volatile int	VectorControlFlag = 1;		/* V_f or Vector control by default */
																				/* 0 = V_f	independants
																				1= Vector control 
																				2= V/f	lis par K_V_f */
volatile int	SpeedControlFlag=1;				/* init a Vit/Pos ctrl au lieu de cmde en courant  */
																				/* 0 = cmde en Courant, 1= Regul Vitesse/Position */
volatile int PosControlFlag=0;					/* init a Speed ctrl */
																				/* 0 = Regul Vitesse,   1= Regul Position */
/* on veut pouvoir tout changer */
volatile int Deflux_Type=0;	//--   /* defluxage continu */
/* Type de defluxage
	0 : pas de defluxage
	1 : par palier
	2 : en continu */

/* on veut pouvoir tout changer */
volatile double 	Tr=Trconst;
volatile double 	Idsref=IdsrefBase; /* 8.944 A */
volatile double Iqsref=0.0;

/* V_f control */
volatile double	Vsref = 0.0;
volatile double	Wsref = 0.0;
//V/f	lis par K_V_f 
double K_V_f=8.48;   // 6.22254; // 220*r2/50 V/Hz et 3 de maniere exp
											//  VDC=600 V, Kvf=8.48 donne  200 rd/s (31.8 Hz) Vds=270V Ias crete=3.9 A
double fs=0.0;

volatile int	InhibFlag=0;
volatile int	InhibEt12=0;

// test crenaux Iqsref
volatile int 	TestIqs=0;
volatile int 	TestIqsDeb=1;
volatile int 	Testinc=0;
volatile double 	EchIqsref=5.0;
volatile int 	Testinclim1=100;
volatile int 	Testinclim2=200;
// test crenaux Wmref
volatile int 	TestWm=0;
volatile double 	EchWmref=10.0;
volatile int 	TestWminc=0;
volatile int 	Testinclim=1000;
// test rampe Wmref
volatile int 	RampeWm=0;
volatile int 	RampePhase=1;
volatile int 	Testinclimph2=300;

void initVar()
{
}
